//Autor: MPIK
//Zalo nov bod a spust jeho editaci. Pedpokld se nzev bodu KN00001-KN99999, prefix lze nastavit v konfiguraci.
//Ureno pro zpracovn poznmek z knih s geografickou tmatikou. Souadnice zskny z map na Seznamu.
//Nov bod zsk automaticky jmno nsledujc po poslednm uloenm.
//Kniha a strana se ukld do tag.
//Tern, obtnost, stav "kee", hint, velikost, krtk popis, atd. vyplnno implicitnmi hodnotami.
//Pomoc vizualizanho skriptu na 4 dky se zobrazuje v GG okn i zatek dlouhho popisu.
//V ablon exportnho makra do POI doplnno zobrazen pidanch tag a potlaeny zbytenosti - univerzln, makro slou dle i pro kee.
//Tento skript je polotovar. Pouit na vlastn nebezpe, dodln vtno.
//Na zaloen body je mono pout GG makra na zskn dalch tag, nap. nadmosk vky a rozdlen na okresy.
//TODO - lokalizace. 

//NUTN - pouvat na nov zaloen databzi, nespoutt ho na databzi ke, jej ppadn nabourn by bylo kritick.

uses ZalozNovyBodAedit;     

{$INCLUDE ZalozNovyBodAedit.config.pas}


var Kategorie, AutorKnihyProDB:Tstringlist;
    PosledniKniha,IDposlednihoBodu,AutorPosledniKnihy : String;
    X, Y : extended;
    B_zeme,B_kraj,B_okres,B_obec : string;
    Skoncit:boolean;
    
function PluginCaption: string;
begin
  Result := 'Zalo nov bod a spust jeho editaci vetn Tag';
end;

function PluginHint: string;
begin
  Result := 'Zalo nov bod a spust jeho editaci vetn Tag';
end;

function PluginIcon: string;
begin
  Result := DecodeBase64('Qk02AwAAAAAAADYAAAAoAAAAEAAAABAAAAABABgAAAAAAAAAAADEDgAAxA4AAAAAAAAAAAAA7ezr 7ezr7ezrAAAAAAAAAAAAAAAAl5eX7ezr7ezr7ezr7ezr7ezr7ezr7ezr7ezr7ezr7ezr7ezrAAAA x8fHx8fHx8fHAAAAAAAAAAAAAAAAl5eX7ezr7ezr7ezr7ezr7ezr7ezr7ezrAAAAx8fH5+fn5+fn 5+fn5+fn5+fnx8fHAAAAAAAAAAAA7ezr7ezr7ezr7ezr7ezrAAAAx8fH5+fn19fX19fX//////// ////5+fn////AAAA7ezr7ezr7ezr7ezr7ezrAAAAx8fH5+fnCAgICAgI19fX19fX19fX//////// AAAA7ezr7ezr7ezr7ezr7ezrAAAAx8fH5+fn////////CAgICAgICAgI19fX////AAAA7ezr7ezr 7ezr7ezr7ezrAAAAx8fH5+fn19fX19fX////////////CAgI////AAAA7ezr7ezr7ezr7ezr7ezr AAAAx8fH5+fnAAAAAAAA19fX19fX19fX////////AAAA7ezr7ezr7ezr7ezr7ezrAAAAx8fH19fX 5+fn9/f3AAAAAAAAAAAA19fX////AAAA7ezr7ezr7ezr7ezr7ezrAAAAx8fH5+fn//////////// 5+fn9/f3AAAA////AAAA7ezr7ezr7ezr7ezr7ezrAAAAx8fH5+fn////////AAD/////////9/f3 ////AAAA7ezr7ezr7ezr7ezr7ezrAAAAx8fH5+fn////////////AAD/AAD/srL/AAD/AAD/7ezr 7ezr7ezr7ezr7ezrAAAAAAAAAAAAAAAA5+fn5+fn5+fn5+fnAAD/AACyAACyAAD/7ezr7ezr7ezr 7ezr7ezr7ezr7ezrl5eXAAAAAAAAAAAAAAAAAAD/AACysrL/AAD/7ezr7ezr7ezr7ezr7ezr7ezr 7ezr7ezr7ezr7ezr7ezrl5eXAAD/AAD/////AAD/7ezr7ezr7ezr7ezr7ezr7ezr7ezr7ezr7ezr 7ezr7ezr7ezr7ezrAAD/AAD/7ezr7ezr');
end;

function PluginFlags: string;
begin
  Result := 'toolbar,global';
end;
              //Parsovn souadnic ze tech formt, pouitch na www.mapy.cz.
              //Zadvn:na map kliknout pravou my, Pidat vlastn bod a z polka zkoprovat hodnotu do formule.
              //TODO formul je modln, do okna GG se sputnm formulem se nelze pepnout AltTab, mus se my. (WinXP, nevm jak jinde.)
              // Stlo by za to i toto trochu automatizovat, nevm jak.
function sourN (souradnice:string): string;
     var sourNst, sourNmin, sourNvt: extended;
     pSt,pM,pV,pN,pCarky:integer;
begin
    pSt:=pos('',souradnice);                      // V GG jsou lep parsovac funkce, kter jsem v dob psan neznal.
    pM:=pos(chr(39),souradnice);     //apostrof
    pV:=pos(chr(34),souradnice);     //uvozovky
    pN:=pos('N',souradnice);
    pCarky := pos(chr(44),souradnice);
               // Souadnice v jednom stringu, N a E oddleny rkou. 
               //Po ppadn zmn zobrazovn na www.mapy.cz nutno parsovn pedlat.
    if pN = 1 then  //N 49 3.12238', E 14 26.38442'
    begin
    
         sourNst := strTofl(copy(souradnice,2,pSt-pN-1));                     
         sourNmin:= strToFl(copy(souradnice,pSt+1,pM-pSt-1)); 
         sourNvt:=0;
    end;
    if pV <> 0 then  //493'8.385"N, 1426'22.536"E
    begin     
         sourNst := strTofl(copy(souradnice,1,pSt-1));
         sourNmin:= strToFl(copy(souradnice,pSt+1,pM-pSt-1));
         sourNvt:=  strToFl(copy(souradnice,pM+1,pV-pM-1));
    end;    
    if pSt = 0 then //49.0524608N, 14.4601011E
    begin
         sourNst := strTofl(copy(souradnice,1,pN-1));
         sourNmin :=0; sourNvt:=0;
    end;
    if pCarky = 0 then begin X:=0; result := '' end else    
       begin X := SourNst+sourNmin/60+sourNvt/3600; result := flToStr(X);end; 
end;

function sourE (souradnice:string): string;
     var sourEst, sourEmin, sourEvt: extended;
     pSt,pM,pV,pCarky,pE:integer;     
begin
    pCarky := pos(chr(44),souradnice);
    souradnice:=trim(copy(souradnice,pCarky+1,30));
    pSt:=pos('',souradnice);
    pM:=pos(chr(39),souradnice);     //apostrof
    pV:=pos(chr(34),souradnice);     //uvozovky
    pE:=pos('E',souradnice);    
    
    if pE = 1 then  // N 49 3.12238', E 14 26.38442'
    begin
         sourEst := strTofl(copy(souradnice,2,pSt-pE-1));
         sourEmin:= strToFl(copy(souradnice,pSt+1,pM-pSt-1));
         sourEvt:=0;
    end;
    if pV <> 0 then  // 493'8.385"N, 1426'22.536"E
    begin
         sourEst := strTofl(copy(souradnice,1,pSt-1));
         sourEmin:= strToFl(copy(souradnice,pSt+1,pM-pSt-1));
         sourEvt:=  strToFl(copy(souradnice,pM+1,pV-pM-1));
    end; 
    if pSt = 0 then // 49.0524608N, 14.4601011E
    begin
         sourEst := strTofl(copy(souradnice,1,pE-1));
         sourEmin :=0; sourEvt:=0;
    end;    
    if pCarky = 0 then begin Y:=0; result := '' end else    
       begin Y := SourEst+sourEmin/60+sourEvt/3600; result := flToStr(Y);end;    
end;

Function PolygonToGS(vstup:string):string;
                     // Pevede nzev kraje z textu, kter vrac tda TGeoPolyList na etzec
var pom:string;      // jak vrac funkce GetStateList
begin
     case vstup OF
     'Jihoesk'        : pom := 'Jihocesky kraj';
     'Jihomoravsk'     : pom := 'Jihomoravsky kraj';
     'Karlovarsk'      : pom := 'Karlovarsky kraj';
     'Krlovhradeck'  : pom := 'Kralovehradecky kraj';
     'Libereck'        : pom := 'Liberecky kraj';
     'Moravskoslezsk'  : pom := 'Moravskoslezsky kraj';
     'Olomouck'        : pom := 'Olomoucky kraj';
     'Pardubick'       : pom := 'Pardubicky kraj';
     'Plzesk'         : pom := 'Plzensky kraj';
     'Praha'            : pom := 'Hlavni mesto Praha';
     'Stedoesk'      : pom := 'Stredocesky kraj';
     'steck'          : pom := 'Ustecky kraj';
     'Vysoina'         : pom := 'Kraj Vysocina';
     'Zlnsk'          : pom := 'Zlinsky kraj';
     
     'Banskobystrick'  : pom := 'Banskobystrick kraj';
     'Bratislavsk'     : pom := 'Bratislavsk kraj';
     'Koick'          : pom := 'Koick kraj';
     'Nitriansky'       : pom := 'Nitriansky kraj';
     'Preovsk'        : pom := 'Preovsk kraj';
     'Treniansky'      : pom := 'Treniansky kraj';
     'Trnavsk'         : pom := 'Trnavsk kraj';
     'ilinsk'         : pom := 'ilinsk kraj';
     
     else pom := vstup;
     end; 
     result:= AnsiToUtf(pom);       
end;


Procedure ZmenaStatu(Sender: TObject);    //Po zmn sttu pepne combobox s kraji na aktuln stt.
                                          //TODO: zmnit i text v comboboxu, zatm zstv postaru.
var kraje:TstringList;
begin
  kraje:=TstringList.create;
  GetStateList(NovyBod_stat.Text, kraje);
  NovyBod_uzemi.items := kraje;
  kraje.free;
end;

Procedure Uzident(Sender: TObject);  // zemn identifikace
//Piad podle souadnic zemi, kraj, okres, obec
var stat,kraj,okres,obec:TGeoPolyList;
S_kraj, S_okres, S_obec : string;
kraje:TstringList;

begin
 stat :=TGeoPolyList.create;
 kraj :=TGeoPolyList.create;
 okres:=TGeoPolyList.create;
 obec:= TGeoPolyList.create;
 stat.init('World');
 sourN(NovyBod_souradnice.text); sourE(NovyBod_souradnice.text);
 B_zeme := stat.FindPolygon(X,Y);
 case (B_zeme)  of
 'Czech Republic' :  begin
                          S_kraj:='CZ kraje'; S_okres:='CZ okresy';S_obec:='CZ PU';
                     end;
 'Slovakia'       :  begin
                          S_kraj:='SK kraje'; S_okres:='SK okresy';S_obec:='';
                     end;
 'Austria'        :  begin
                          S_kraj:='AT Land'; S_okres:='AT Bezirk';S_obec:='';
                     end; 
 'Hungary'        :  begin
                          S_kraj:='HU megye'; S_okres:='';S_obec:='';
                     end; 
 else                begin
                          S_kraj:=''; S_okres:='';S_obec:='';
                     end; 
                                                                   
 end;
 
 if S_kraj  <> '' then kraj.init(S_kraj);
 if S_okres <> '' then okres.init(S_okres);
 if S_obec  <> '' then obec.init(S_obec);

 
 
 NovyBod_zeme.caption:='Stt:'+B_zeme;
 B_kraj := kraj.FindPolygon(X,Y);    
 NovyBod_kraj.caption:='Kraj: '+B_kraj;
 if UrcitOkres <> '0' then 
 begin
 B_okres := okres.FindPolygon(X,Y);    
 NovyBod_okres.caption:='Okres: '+B_okres;
 end;
 if UrcitPU <> '0' then
 begin 
 B_obec := obec.FindPolygon(X,Y);    
 NovyBod_obec.caption:='Pov.ad: '+B_obec; 
 end;
 
 NovyBod_stat.text:=AnsiToUTF(B_zeme);
 NovyBod_uzemi.text:=PolygonToGS(B_kraj);
 
 kraje:=TstringList.create;
 GetStateList(NovyBod_stat.Text, kraje);
 NovyBod_uzemi.items := kraje;
 kraje.free;
 if (B_kraj <> '') or (PovolitEditaciStatuAkraje <> '0') then 
 begin 
   NovyBod_stat.Enabled := false; 
   NovyBod_uzemi.Enabled := false;
 end;  
 stat.free;
 kraj.free;
 okres.free;
 obec.free;
 
end;

procedure PluginStart;
 
begin 
 skoncit:=false;
 if (GEOGET_DBNAME = 'geoget') or (GEOGET_DBNAME = 'Waymark') then
 begin showmessage('Tento skript nelze spustit nad databz ke nebo waymark'); skoncit:=true; exit;  end; 
 Kategorie:=TstringList.create;
 AutorKnihyProDB := TstringList.create;

end;
  
procedure PluginWork;   //Jen kvli naplnn seznamu hodnot tagu pro Combo box na formuli.
                        //Pokud by to lo jinak, nebylo by nutno PluginWork spoutt.
var Kat,AutorKnihyDB :string;   
begin
if skoncit then exit;
IDposlednihoBodu:=PrefixNovehoBodu+'00000';
Kat := GC.TagValues('Kniha');
if Kategorie.IndexOf(UtfToAnsi(Kat)) = -1 then Kategorie.Add(UtfToAnsi(Kat));
PosledniKniha:= UtfToAnsi(Kat);
AutorKnihyDB := GC.TagValues('AutorKnihy');
if  AutorKnihyProDB.IndexOf(UtfToAnsi(AutorKnihyDB)) = -1 then AutorKnihyProDB.Add(UtfToAnsi(AutorKnihyDB));
AutorPosledniKnihy := UtfToAnsi(AutorKnihyDB);
IDposlednihoBodu := GC.ID;   
//po projet cel databze zde zstane ID poslednho bodu
// z njakho dvodu nejde dupIgnore, plnm stringlist pouitmi kategoriemi tagu Kniha
// Posledn pouitou dvm jako implicitn

end;

procedure PluginStop;  
var
//var t :  TSQLiteTable; 

posledniCislo :string;
noveCislo, prefix, cislo : string;
bod : TGeo;   
kraje : TStringList;  
Neopakuj:boolean;
 
begin  
 if skoncit then exit;
 //obec.init('')
 //GeoDBselect('Pokus');
 NovyBod_stat.onChange := @ZmenaStatu;
 NovyBod_souradnice.onExit := @Uzident;
 //t :=	Geoget_DB.GetTable ('SELECT id FROM geocache ORDER BY id DESC', false);
 //posledniCislo:=t.Fields[0] ;
 posledniCislo := IDposlednihoBodu;
 prefix:=copy(posledniCislo,1,2);
 cislo:=inttostr(strtoint(copy(posledniCislo,3,10))+1);
 noveCislo := prefix+copy('00000',1,5-length(cislo))+cislo;
 NovyBod_ID.text := noveCislo; 

        kraje := TstringList.Create;       
        bod := TGeo.create;
        bod.SetDefault;
        bod.ID:=noveCislo;
        bod.Author:=ansiToUtf(AutorZaznamu);
        bod.size:='not chosen';
        bod.cachestatus:=0;
        GetStateList(NovyBod_stat.text,kraje);
        NovyBod_uzemi.items := kraje;
        kraje.free;
        NovyBod_kniha.Items := Kategorie;
        NovyBod_kniha.text:= PosledniKniha;
        NovyBod_AutorKnihy.Items := AutorKnihyProDB;
        NovyBod_AutorKnihy.text := AutorPosledniKnihy;
        Kategorie.free;
        AutorKnihyProDB.free;
        Neopakuj := true;
        

   repeat
        Neopakuj := true;
        if NovyBod.ShowModal = 1 then 
        begin       
        if (NovyBod_souradnice.text = '') or 
        (sourN(NovyBod_souradnice.text)='') or 
        (sourE(NovyBod_souradnice.text)='')
        then 
        begin 
              showMessage('Vypl souadnice');
              Neopakuj := false;
              continue;
        end;
        if NovyBod_Nazev.text = '' then 
        begin 
              showMessage('Vypl nzev');
              Neopakuj := false;
              continue;
        end;
        if NovyBod_Strana.text = '' then 
        begin 
              showMessage('Vypl slo strany');
              Neopakuj := false;
              continue;
        end;                              
        bod.Hidden:= now;
        bod.CacheType:='Kniha';
        bod.UpdateListing(AnsiToUtf(NovyBod_Popis.text),'','',1,1);
        bod.coordX:= FlToStr(X);
        bod.coordY:= FlToStr(Y); 
   
        bod.Name := AnsiToUtf(NovyBod_Nazev.text);  
        bod.Country:=AnsiToUtf(NovyBod_Stat.text);
        bod.State:=AnsiToUtf(NovyBod_Uzemi.text);      
        bod.save;
        case B_zeme of
          'Czech Republic' : begin
                                 bod.TagAdd('CZ kraj',AnsiToUtf(B_kraj));
                                 if UrcitOkres <> '0' then
                                    bod.TagAdd('CZ okres',AnsiToUtf(B_okres));
                                 if UrcitPU <> '0' then
                                    bod.TagAdd('CZ Povereny urad',AnsiToUtf(B_obec));
                             end;
          'Slovakia'       : begin
                                 bod.TagAdd('SK kraj',AnsiToUtf(B_kraj));
                                 if UrcitOkres <> '0' then 
                                    bod.TagAdd('SK okres',AnsiToUtf(B_okres));
                             end;  
          'Austria'       : begin
                                 bod.TagAdd('AT Land',AnsiToUtf(B_kraj));
                                 bod.TagAdd('AT Bezirk',AnsiToUtf(B_okres));
                            end;  
          'Hungary'       : begin
                                 bod.TagAdd('HU megye',AnsiToUtf(B_kraj));
                            end;                                                                  
        end;
        bod.TagAdd('Kniha',AnsiToUtf(NovyBod_kniha.text));
        bod.TagAdd('AutorKnihy',AnsiToUtf(NovyBod_AutorKnihy.text));
        bod.TagAdd('strana',AnsiToUtf(NovyBod_strana.text));
        bod.listadd;
        end;
   until Neopakuj;
        bod.free;
     


end;